=== debian/changelog ===
ycm-cmake-modules (0.13.0-2) unstable; urgency=medium

  * Team Upload.
  * Add patch to fix doc building (Closes: #997429)
  * Bump Standards-Version to 4.6.0 (no changes needed)

 -- Nilesh Patra <nilesh@debian.org>  Fri, 29 Oct 2021 20:48:31 +0530

ycm-cmake-modules (0.13.0-1) unstable; urgency=medium

  * New upstream version 0.13.0

 -- Daniele E. Domenichelli <ddomenichelli@drdanz.it>  Wed, 18 Aug 2021 17:57:20 +0530

ycm-cmake-modules (0.12.2-1) unstable; urgency=medium

  [ Nilesh Patra ]
  * Declare compliance with policy 4.5.1

  [ Daniele E. Domenichelli ]
  * New upstream release (0.12.2)

 -- Daniele E. Domenichelli <ddomenichelli@drdanz.it>  Wed, 19 May 2021 16:27:22 +0200
