=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE = 1

%:
	dh $@ --without build-stamp --with linktree

override_dh_auto_configure:
	dh_auto_configure -- \
	                     -DSPHINX_HTML=ON \
	                     -DSPHINX_MAN=ON \
	                     -DCMAKE_INSTALL_DOCDIR=share/doc/ycm-cmake-modules \
	                     -DCMAKE_INSTALL_LIBDIR=share \
	                     -DCMAKE_SKIP_INSTALL_ALL_DEPENDENCY=OFF

override_dh_auto_install:
	dh_auto_install

	# Reproducible builds: remove build path from documentation generated by sphinx.
	sed -i -e 's|$(CURDIR)|.|g' $(CURDIR)/debian/ycm-cmake-modules/usr/share/doc/ycm-cmake-modules/html/todo.html

	# COPYING files are not necessary since the are already represented in the copyright file
	find $(CURDIR)/debian/ycm-cmake-modules/usr/share/YCM -name "COPYING.*" -delete

	# README files should be in documentation
	mkdir -p $(CURDIR)/debian/ycm-cmake-modules/usr/share/doc/ycm-cmake-modules
	find $(CURDIR)/debian/ycm-cmake-modules/usr/share/YCM -name "README.*" -exec \
	    mv {} $(CURDIR)/debian/ycm-cmake-modules/usr/share/doc/ycm-cmake-modules/ \;
	find $(CURDIR)/debian/ycm-cmake-modules/usr/share/YCM/cmake-*/README -print | \
	    sed -ne '/\(.\+\)\/usr\/share\/YCM\/cmake-\([^\/]\+\)\/README/s//mv & \1\/usr\/share\/doc\/ycm-cmake-modules\/README.cmake-\2/p' | sh

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
endif

override_dh_auto_build-indep:
